<?php
	/**
	* G4HDU Goto Top plugin
	*
	* Copyright (C) 2008-2016 Barry Keal G4HDU http://e107.keal.me.uk
	* blankd under the terms and conditions of the
	* GNU General Public License (http://www.gnu.org/licenses/gpl.txt)
	*
	* @author Barry Keal e107@keal.me.uk>
	* @copyright Copyright (C) 2008-2016 Barry Keal G4HDU
	* @license GPL
	* @version 1.0.0
	*
	*
	*/
	if (!defined('e107_INIT')) {
		exit;
	}
	$colourCodes = array(
		'trans' => 'Transparent',
		'F0F8FF' => 'Alice blue',
		'FAEBD7' => 'Antique white',
		'00FFFF' => 'Cyan',
		'7FFFD4' => 'Aquamarine',
		'F0FFFF' => 'Azure',
		'F5F5DC' => 'Beige',
		'FFE4C4' => 'Bisque',
		'000000' => 'Black',
		'FFEBCD' => 'Blanched almond ',
		'0000FF' => 'Blue',
		'8A2BE2' => 'Blue violet',
		'A52A2A' => 'Brown',
		'DEB887' => 'Burlywood',
		'5F9EA0' => 'Cadet blue',
		'7FFF00' => 'Chartreuse',
		'D2691E' => 'Chocolate',
		'FF7F50' => 'Coral',
		'6495ED' => 'Cornflower blue',
		'FFF8DC' => 'Cornsilk',
		'DC143C' => 'Crimson',
		'00008B' => 'Dark blue',
		'008B8B' => 'Dark cyan',
		'B8860B' => 'Dark goldenrod',
		'006400' => 'Dark green',
		'A9A9A9' => 'Dark grey',
		'BDB76B' => 'Dark khaki',
		'8B008B' => 'Dark magenta',
		'556B2F' => 'Dark olive green',
		'FF8C00' => 'Dark orange',
		'9932CC' => 'Dark orchid',
		'8B0000' => 'Dark red',
		'E9967A' => 'Dark salmon',
		'8FBC8F' => 'Dark sea green',
		'483D8B' => 'Dark slate blue',
		'2F4F4F' => 'Dark slate grey',
		'00CED1' => 'Dark turquoise',
		'9400D3' => 'Dark violet',
		'FF1493' => 'Deep pink',
		'00BFFF' => 'Deep skyblue',
		'696969' => 'Dim grey',
		'1E90FF' => 'Dodger blue',
		'B22222' => 'Firebrick',
		'FFFAF0' => 'Floral white',
		'228B22' => 'Forest green',
		'FF00FF' => 'Magenta',
		'DCDCDC' => 'Gainsboro',
		'F8F8FF' => 'Ghost white',
		'FFD700' => 'Gold',
		'DAA520' => 'Goldenrod',
		'008000' => 'Green',
		'ADFF2F' => 'Green yellow',
		'808080' => 'Grey',
		'F0FFF0' => 'Honeydew',
		'FF69B4' => 'Hotpink',
		'CD5C5C' => 'Indian red',
		'4B0082' => 'Indigo',
		'FFFFF0' => 'Ivory',
		'F0E68C' => 'Khaki',
		'E6E6FA' => 'Lavender',
		'FFF0F5' => 'Lavender blush',
		'7CFC00' => 'Lawn green',
		'FFFACD' => 'Lemon chiffon',
		'ADD8E6' => 'Light blue',
		'F08080' => 'Lightcoral',
		'E0FFFF' => 'Light cyan',
		'FAFAD2' => 'Light goldenrod yellow',
		'90EE90' => 'Light green',
		'D3D3D3' => 'Light grey',
		'FFB6C1' => 'Light pink',
		'FFA07A' => 'Light salmon',
		'20B2AA' => 'Light sea green',
		'87CEFA' => 'Light sky blue',
		'778899' => 'Light slate grey',
		'B0C4DE' => 'Light steel blue',
		'FFFFE0' => 'Light yellow',
		'00FF00' => 'Lime',
		'32CD32' => 'Lime green',
		'FAF0E6' => 'Linen',
		'800000' => 'Maroon',
		'66CDAA' => 'Medium aquamarine',
		'0000CD' => 'Medium blue',
		'BA55D3' => 'Medium orchid',
		'9370D0' => 'Medium purple',
		'3CB371' => 'Medium seagreen',
		'7B68EE' => 'Medium slateblue',
		'00FA9A' => 'Medium springgreen',
		'48D1CC' => 'Medium turquoise',
		'C71585' => 'Medium violetred',
		'191970' => 'Midnight blue',
		'F5FFFA' => 'Mint cream',
		'FFE4E1' => 'Misty rose',
		'FFE4B5' => 'Moccasin',
		'FFDEAD' => 'Navajo white',
		'000080' => 'Navy',
		'FDF5E6' => 'Old lace',
		'808000' => 'Olive',
		'6B8E23' => 'Olive drab',
		'FFA500' => 'Orange',
		'FF4500' => 'Orange red',
		'DA70D6' => 'Orchid',
		'EEE8AA' => 'Pale goldenrod',
		'98FB98' => 'Pale green',
		'AFEEEE' => 'Pale turquoise',
		'DB7093' => 'Pale violet red',
		'FFEFD5' => 'Papayawhip',
		'FFDAB9' => 'Peachpuff',
		'CD853F' => 'Peru',
		'FFC0CB' => 'Pink',
		'DDA0DD' => 'Plum',
		'B0E0E6' => 'Powder blue',
		'800080' => 'Purple',
		'FF0000' => 'Red',
		'BC8F8F' => 'Rosy brown',
		'4169E1' => 'Royal blue',
		'8B4513' => 'Saddle brown',
		'FA8072' => 'Salmon',
		'F4A460' => 'Sandy brown',
		'2E8B57' => 'Seagreen',
		'FFF5EE' => 'Seashell',
		'A0522D' => 'Sienna',
		'C0C0C0' => 'Silver',
		'87CEEB' => 'Skyblue',
		'6A5ACD' => 'Slate blue',
		'708090' => 'Slate grey',
		'FFFAFA' => 'Snow',
		'00FF7F' => 'Spring green',
		'4682B4' => 'Steel blue',
		'D2B48C' => 'Tan',
		'008080' => 'Teal',
		'D8BFD8' => 'Thistle',
		'FF6347' => 'Tomato',
		'40E0D0' => 'Turquoise',
		'EE82EE' => 'Violet',
		'F5DEB3' => 'Wheat',
		'FFFFFF' => 'White',
		'F5F5F5' => 'White smoke',
		'FFFF00' => 'Yellow',
		'9ACD32' => 'Yellow green'
		);
?>